<?php
/**
 * SMF Arcade
 *
 * @package SMF Arcade
 * @version 2.6
 * @license https://web-develop.ca/index.php?page=arcade_license_BSD2 BSD 2
 */

if (!defined('SMF'))
	die('Hacking attempt...');

function ManageRuffleUpload()
{
	global $scripturl, $txt, $modSettings, $context, $boarddir, $sourcedir, $smcFunc, $settings, $user_settings, $cookiename, $user_info, $smfVersion;

	isAllowedTo('arcade_admin');
	require_once($boarddir . '/ArcadeSources/Subs-Arcade.php');
	$dest = str_replace('\\', '/', $settings['default_theme_dir']) . '/arcade_scripts/ruffle';
	loadTemplate('ManageRuffle');
	if ($smfVersion == 'v2.1')
	{
		$modSettings['cookieTime'] = 3153600;
		createToken('admin', 'post');
	}
	else
		require_once($sourcedir . '/Subs-Auth.php');

	if (!is_writable($dest) && !chmod($dest, 0755))
		fatal_lang_error('arcade_not_writable', false, array($dest));

	$context['post_max_size'] = arcade_return_bytes(ini_get('post_max_size')) / 1048576;
	$context['post_max_size'] = preg_replace('/[^0-9\.]/', '', $context['post_max_size']);
	$context['post_max_size'] = round($context['post_max_size'], 2);

	// Template
	$context['html_headers'] .= '
	<script type="text/javascript">
		function ruffle_message() {
			if (document.getElementById("ruffle_retrieval")) {
				document.getElementById("ruffle_retrieval").style.display = "block";
			}
		}
		function ruffle_external_form() {
			if (document.getElementById("override").checked) {
				document.getElementById("override2").value = "1";
			}
			if (document.getElementById("ruffle_option"))
				document.getElementById("ruffle_option").style.display = "none";
			if (document.getElementById("upload_form"))
				document.getElementById("upload_form").style.display = "none";
			if (document.getElementById("external_form")) {
				document.getElementById("external_form").style.display = "none";
				ruffle_message();
				document.getElementById("external_form").submit();
			}
		}
		function ruffle_external_form_github() {
			if (document.getElementById("override").checked)
				document.getElementById("override2").value = "1";
			var actionString = document.getElementById("external_form").action;
			if (document.getElementById("ruffle_option"))
				document.getElementById("ruffle_option").style.display = "none";
			if (document.getElementById("upload_form"))
				document.getElementById("upload_form").style.display = "none";
			if (document.getElementById("external_form")) {
				document.getElementById("external_form").style.display = "none";
				document.getElementById("external_form").action = actionString.slice(0, -1) + "2";
				ruffle_message();
				document.getElementById("external_form").submit();
			}
		}
		function ruffle_upload_form() {
			if (document.getElementById("ruffle_option"))
				document.getElementById("ruffle_option").style.display = "none";
			if (document.getElementById("external_form"))
				document.getElementById("external_form").style.display = "none";
			if (document.getElementById("upload_form"))
				document.getElementById("upload_form").style.display = "none";
			ruffle_message();
		}
		var time = 1;
		setInterval(function() {
			var seconds = time % 60;
			var minutes = (time - seconds) / 60;
			if (seconds.toString().length == 1) {
				seconds = "0" + seconds;
			}
			if (minutes.toString().length == 1) {
				minutes = "0" + minutes;
			}
			if (document.getElementById("time"))
				document.getElementById("time").innerHTML = "' . $txt['arcade_upload_please_wait'] . ' " + seconds;
			time++;
		}, 1000);
	</script>';
	$context['ruffle_external'] = !empty($modSettings['arcadeRuffleExternalLink']) ? $modSettings['arcadeRuffleExternalLink'] : $modSettings['arcadeRuffleDefaultLink'];
	$context['sub_template'] = 'manage_ruffle_upload';
}

function ManageRuffleUpload2()
{
	global $txt, $scripturl, $modSettings, $settings, $context, $cookiename, $smfVersion;

	isAllowedTo('arcade_admin');
	//checkSession('post');
	$postVar = !empty($_FILES['attachment']) ? $_FILES['attachment'] : array();
	$override = isset($_POST['override']) ? ';overwrite=1' : '';
	list($fileExists, $_SESSION['arcade_ruffle_update'], $newname, $_SESSION['arcade_ruffle_update_file']) = array(0, 0, '', '');

	if ($smfVersion == 'v2.1')
	{
		$modSettings['cookieTime'] = 3153600;
		createToken('admin', 'post');
	}

	if (empty($postVar))
		fatal_lang_error($txt['arcade_upload_nofile'], false);

	foreach ($postVar['tmp_name'] as $n => $dummy)
	{
		if ($postVar['name'][$n] == '')
			continue;

		$postVar['name'][$n] = preg_replace(array('/\s/', '/\.[\.]+/', '/[^\w_\.\-]/'), array('_', '.', ''), $postVar['name'][$n]);
		$newname = trim(basename($postVar['name'][$n]));
		$target = str_replace('\\', '/', $settings['default_theme_dir']) . '/arcade_scripts/ruffle';
		$target = rtrim($target, '/');

		$tmp_name = $postVar['tmp_name'][$n];

		if (mb_substr(mb_strtolower($newname), -3) !== '.gz' && mb_substr(mb_strtolower($newname), -4) !== '.zip')
			continue;

		if (!file_exists($target) && !mkdir($target, 0755))
			fatal_lang_error('arcade_not_writable', false, array($target));

		if (!is_writable($target) && !chmod($target, 0755))
			fatal_lang_error('arcade_not_writable', false, array($target));

		if (!file_exists($target . '/' . $newname))
		{
			if (empty(filesize($tmp_name)))
			{
				if (file_exists($tmp_name))
					unlink($tmp_name);
				clearstatcache();
				fatal_lang_error('arcade_upload_file_size');
			}

			$fileExists = 0;
			$com = fopen($target . '/' . $newname, "ab");
			$in = fopen($tmp_name, "rb");
			if ($in)
			{
				// pause on every MB
				while ($buff = fread($in, 1048576))
				{
					fwrite($com, $buff);
					sleep(3);
				}
				fclose($in);
			}
			fclose($com);

			//move_uploaded_file($postVar['tmp_name'][$n], $target . '/' . $newname);

			if (!file_exists($target . '/' . $newname))
				fatal_lang_error('arcade_upload_file', false);

			@chmod($target . '/' . $newname, 0755);
		}
		else
			$fileExists = 1;
	}

	$_SESSION['arcade_ruffle_update_file'] = $newname;
	if (!empty($newname) && empty($fileExists)) {
		$_SESSION['arcade_ruffle_update'] = 1;
	}
	elseif (!empty($fileExists)) {
		$_SESSION['arcade_ruffle_update'] = 2;
	}
	else {
		$_SESSION['arcade_ruffle_update'] = 0;
	}

	redirectexit($scripturl . '?action=admin;area=arcademaintenance;sa=ruffle_replace' . $override);
}

function ManageRuffleReplace()
{
	global $scripturl, $settings, $sourcedir, $context, $txt;

	require_once($sourcedir . '/Subs-Package.php');
	loadTemplate('ManageRuffle');
	isAllowedTo('arcade_admin');
	$_SESSION['arcade_ruffle_update'] = !empty($_SESSION['arcade_ruffle_update']) ? (int)$_SESSION['arcade_ruffle_update'] : 0;
	$_SESSION['arcade_ruffle_update_file'] = !empty($_SESSION['arcade_ruffle_update_file']) ? $_SESSION['arcade_ruffle_update_file'] : '';
	$overwrite = isset($_REQUEST['overwrite']) && $_REQUEST['overwrite'] == '1' ? true : false;

	$context['html_headers'] .= '
		<script type="text/javascript">
			if (document.getElementById("ruffle_retrieval"))
				document.getElementById("ruffle_retrieval").style.display = "none";
			var time = 6;
			setInterval(function() {
				var seconds = time % 60;
				var minutes = (time - seconds) / 60;
				if (seconds.toString().length == 1) {
					seconds = "0" + seconds;
				}
				if (minutes.toString().length == 1) {
					minutes = "0" + minutes;
				}
				if (document.getElementById("time"))
					document.getElementById("time").innerHTML = "' . $txt['arcade_upload_please_wait'] . ' " + seconds;
				time--;
				if (time == 0) {
				window.location.href = "' . $scripturl . '?action=admin;area=arcademaintenance;sa=ruffle";
				}
			}, 1000);
		</script>';
	$checkArchive = ManageRuffleVersion($_SESSION['arcade_ruffle_update_file'], $overwrite);
	$context['ruffle_message'] = $txt['arcade_ruffle_abort'];
	switch($_SESSION['arcade_ruffle_update']) {
		CASE 1:
			if (!empty($checkArchive)) {
				$context['ruffle_message'] = '<div>' . sprintf($txt['arcade_upload_complete'], $_SESSION['arcade_ruffle_update_file']) . '<div>' . $checkArchive;
				ManageRuffleFiles($_SESSION['arcade_ruffle_update_file'], $overwrite);
			}
			break;
		CASE 2:
			if (!empty($checkArchive)) {
				$context['ruffle_message'] = '<div>' . sprintf($txt['arcade_upload_exists'], $_SESSION['arcade_ruffle_update_file']) . '</div>' . $checkArchive;
				ManageRuffleFiles($_SESSION['arcade_ruffle_update_file'], $overwrite);
			}
			break;
		DEFAULT:
			$context['ruffle_message'] = $txt['arcade_upload_nofile'];
	}
	if ($context['ruffle_message'] == $txt['arcade_ruffle_abort']) {
		$file = str_replace('\\', '/', $settings['default_theme_dir']) . '/arcade_scripts/ruffle/' . $_SESSION['arcade_ruffle_update_file'];
		if (file_exists($file))
			unlink($file);
	}

	unset($_SESSION['arcade_ruffle_update']);
	$context['sub_template'] = 'manage_ruffle_replace';
}

function ManageRuffleVersion($archive, $overwrite = false)
{
	global $modSettings, $txt;
	$pattern = "/\d{4}\_\d{2}\_\d{2}/";

	if (preg_match($pattern, basename($archive), $matches)) {
		$archiveVersion = str_replace('_', '.', $matches[0]);
	}

	if (empty($archiveVersion) || empty($modSettings['arcadeRuffleVersion']))
		return '';

	if (version_compare($modSettings['arcadeRuffleVersion'], $archiveVersion, '<')) {
		// current is older than archive ~ replace files...
		return '<div style="padding: 1em;">' . $txt['arcade_ruffle_new'] . '</div>';
	}
	elseif (version_compare($modSettings['arcadeRuffleVersion'], $archiveVersion, '=')) {
		// current same as archive ~ possible issue? replace files...
		return '<div style="padding: 1em;">' . $txt['arcade_ruffle_current'] . '</div>';
	}
	elseif (!empty($overwrite)) {
		// force overwrite flagged, replace files...
		return '<div style="padding: 1em;">' . $txt['arcade_ruffle_overwrite'] . '</div>';
	}
	elseif (version_compare($modSettings['arcadeRuffleVersion'], $archiveVersion, '>')) {
		// current is newer than archive ~ do nothing...
		return '';
	}
}

function ManageRuffleVersionUpdate($archive, $overwrite = false)
{
	global $modSettings;
	isAllowedTo('arcade_admin');
	$pattern = "/\d{4}\_\d{2}\_\d{2}/";

	if (preg_match($pattern, basename($archive), $matches)) {
		$archiveVersion = str_replace('_', '.', $matches[0]);
	}

	if (empty($archiveVersion))
		return array();

	if (version_compare($modSettings['arcadeRuffleVersion'], $archiveVersion, '<') || !empty($overwrite)) {
		$update['arcadeRuffleVersion'] = $archiveVersion;
		updateSettings($update);
		//$modSettings['arcadeRuffleVersion'] = $archiveVersion;
	}
}

function ManageRuffleFiles($archive, $overwrite = false)
{
	global $settings, $smfVersion, $modSettings;
	isAllowedTo('arcade_admin');
	$sourcePath = str_replace('\\', '/', $settings['default_theme_dir']) . '/arcade_scripts/ruffle';
	$from =  $sourcePath . '/' . $archive;
	$target = 'updated_files';
	$path = $sourcePath . '/' . $target;
	clearstatcache(false, $sourcePath . '/' . $target);
	if (!is_dir($sourcePath . '/' . $target)) {
		@mkdir($sourcePath . '/' . $target, 0755, true);
		@chmod($sourcePath . '/' . $target, 0755);
	}

	if (file_exists($path)) {
		$dir_iterator = new RecursiveDirectoryIterator($path);
		$iterator = new RecursiveIteratorIterator($dir_iterator, RecursiveIteratorIterator::CHILD_FIRST);
		$dirFiles = array();

		foreach ($iterator as $file)
			if (mb_substr($file, -1) != '.' && mb_substr($file, -2) != '..')
				$dirFiles[] = $file;

		foreach($dirFiles as $file) {
			if (file_exists($path . '/' . $file))
				unlink($path . '/' . $file);
		}
	}

	if (mb_substr(mb_strtolower($archive) , -3) == '.gz')
	{
		$out_file_name = mb_substr($from, 0, -3);
		try {
			$phar = new PharData($from);
			$phar->decompress();
		}
		catch (Exception $e) {
			$error = sprintf($txt['arcade_ruffle_install_error'], $archive);
			$err = arcade_html_entity_decode($error, 2, 2);
			log_error($err);
		}

		if (file_exists($out_file_name))
		{
			if (file_exists($from))
				@unlink($from);
			$from = $out_file_name;
			$archive = mb_substr($archive, 0, -3);
		}
		else
			fatal_lang_error('arcade_file_non_read', false);
	}

	if (mb_substr(mb_strtolower($archive) , -4) == '.zip') {
		$files = arcadeUnzip($from, $path . '/', true, false);
	}
	clearstatcache(false, $path);
	$dir_iterator = new RecursiveDirectoryIterator($path);
	$iterator = new RecursiveIteratorIterator($dir_iterator, RecursiveIteratorIterator::CHILD_FIRST);
	list($wasm, $sourceDirFiles) = array(array(), array());

	foreach ($iterator as $file)
		if (mb_substr($file, -1) != '.' && mb_substr($file, -2) != '..') {
			$filex = mb_strtolower($file);
			if (mb_substr($filex , -5) == '.wasm' || basename($filex) == 'ruffle.js' || basename($filex) == 'ruffle.js.map')
				$sourceDirFiles[] = basename($file);
			if (mb_substr($filex, -5) == '.wasm')
				$wasm[] = basename($filex);
		}

	if (file_exists($path) && !empty($wasm) && !empty($sourceDirFiles) && count($sourceDirFiles) > 2) {
		$files = glob($sourcePath . '/*');
		foreach($files as $file){
			if(is_file($file) && basename($file) !== '.htaccess' && basename($file) !== 'index.php')
				unlink($file);
		}
		$dir_iterator = new RecursiveDirectoryIterator($path);
		$iterator = new RecursiveIteratorIterator($dir_iterator, RecursiveIteratorIterator::CHILD_FIRST);
		$dirFiles = array();

		foreach ($iterator as $file)
			if (mb_substr($file, -1) != '.' && mb_substr($file, -2) != '..')
				$dirFiles[] = basename($file);
		$count = 0;
		foreach($dirFiles as $file) {
			copy($path . '/' . $file, $sourcePath . '/' . $file);
			$count++;
		}
		arcadeRmdir($path);
		if (file_exists($from))
			unlink($from);
		if ($count > 2)
			ManageRuffleVersionUpdate($archive, $overwrite);
	}
}

function ManageRuffleGetFileName($url, $realfilename = '')
{
	$content = get_headers($url,1);
	$content = array_change_key_case($content, CASE_LOWER);

    // by header
	if ($content['content-disposition']) {
		$tmp_name = explode('=', $content['content-disposition']);
		if ($tmp_name[1])
			$realfilename = trim($tmp_name[1],'";\'');
	}
	else {
		$stripped_url = preg_replace('/\\?.*/', '', $url);
		$realfilename = basename($stripped_url);
	}

	return $realfilename;
}

function ManageRuffleExternal($gitHub = '', $override = false)
{
	global $modSettings, $settings, $scripturl;

	isAllowedTo('arcade_admin');
	$overwrite = isset($_POST['override2']) && $_POST['override2'] == '1' ? ';overwrite=1' : (!empty($override) ? ';overwrite=1' : '');

	if (empty($gitHub)) {
		$default = !empty($modSettings['arcadeRuffleDefaultLink']) ? $modSettings['arcadeRuffleDefaultLink'] : '';
		$url = !empty($modSettings['arcadeRuffleExternalLink']) ? $modSettings['arcadeRuffleExternalLink'] : $default;
		$fileName = ManageRuffleGetFileName($url, '');
	}
	else {
		$url = $gitHub;
		$fileName = basename($gitHub);
	}

	if (empty($url) || empty($fileName))
		return false;

	$outFileName = str_replace('\\', '/', $settings['default_theme_dir']) . '/arcade_scripts/ruffle/' . $fileName;
    if(is_file($url)) {
        copy($url, $outFileName);
    }
	else {
		file_put_contents($outFileName, file_get_contents($url));
    }

	$fileExists = file_exists($outFileName) ? true : false;
	$_SESSION['arcade_ruffle_update_file'] = $fileName;
	if (!empty($newname) && empty($fileExists)) {
		$_SESSION['arcade_ruffle_update'] = 1;
	}
	elseif (!empty($fileExists)) {
		$_SESSION['arcade_ruffle_update'] = 2;
	}
	else {
		$_SESSION['arcade_ruffle_update'] = 0;
		unlink($outFileName);
	}

	redirectexit($scripturl . '?action=admin;area=arcademaintenance;sa=ruffle_replace' . $overwrite);
}

function ManageRuffleExternalGitHub()
{
	$override = isset($_POST['override2']) && $_POST['override2'] == '1' ? true : false;
	$gitHubLink = ManageRuffleExternalGitHubLink();
	ManageRuffleExternal($gitHubLink, $override);
}

function ManageRuffleExternalGitHubLink()
{
	$html = file_get_contents('https://ruffle.rs/#download');

	$htmlDom = new DOMDocument;
	libxml_use_internal_errors(true);
	@$htmlDom->loadHTML($html);
	$links = $htmlDom->getElementsByTagName('a');
	$extractedLinks = array();

	foreach($links as $link){
		$linkText = $link->nodeValue;
		if ($linkText == 'Self Hosted') {
			$linkHref = $link->getAttribute('href');
			if(strlen(trim($linkHref)) == 0){
				continue;
			}
			if($linkHref[0] == '#'){
				continue;
			}
			$href = $linkHref;
			break;
		}
	}

	return !empty($href) ? $href : '';
}

?>